package io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.model.ResourceRequirementsBuilder;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.fabric8.kubernetes.api.model.ResourceRequirements;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.model.ResourceRequirementsFluent;
import java.util.Iterator;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.Integer;
import io.fabric8.kubernetes.api.model.Toleration;
import java.lang.Long;
import io.fabric8.kubernetes.api.model.Affinity;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public interface ImageRegistrySpecFluent<A extends io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public io.fabric8.kubernetes.api.model.Affinity getAffinity();
  public A withAffinity(io.fabric8.kubernetes.api.model.Affinity affinity);
  public java.lang.Boolean hasAffinity();
  public java.lang.Boolean getDefaultRoute();
  public A withDefaultRoute(java.lang.Boolean defaultRoute);
  public java.lang.Boolean hasDefaultRoute();
  public java.lang.Boolean getDisableRedirect();
  public A withDisableRedirect(java.lang.Boolean disableRedirect);
  public java.lang.Boolean hasDisableRedirect();
  public java.lang.String getHttpSecret();
  public A withHttpSecret(java.lang.String httpSecret);
  public java.lang.Boolean hasHttpSecret();
  
  /**
   * Method is deprecated. use withHttpSecret instead.
   */
  @java.lang.Deprecated
  public A withNewHttpSecret(java.lang.String arg0);
  public java.lang.String getLogLevel();
  public A withLogLevel(java.lang.String logLevel);
  public java.lang.Boolean hasLogLevel();
  
  /**
   * Method is deprecated. use withLogLevel instead.
   */
  @java.lang.Deprecated
  public A withNewLogLevel(java.lang.String arg0);
  public java.lang.Long getLogging();
  public A withLogging(java.lang.Long logging);
  public java.lang.Boolean hasLogging();
  public java.lang.String getManagementState();
  public A withManagementState(java.lang.String managementState);
  public java.lang.Boolean hasManagementState();
  
  /**
   * Method is deprecated. use withManagementState instead.
   */
  @java.lang.Deprecated
  public A withNewManagementState(java.lang.String arg0);
  public A addToNodeSelector(java.lang.String key,java.lang.String value);
  public A addToNodeSelector(java.util.Map<java.lang.String,java.lang.String> map);
  public A removeFromNodeSelector(java.lang.String key);
  public A removeFromNodeSelector(java.util.Map<java.lang.String,java.lang.String> map);
  public java.util.Map<java.lang.String,java.lang.String> getNodeSelector();
  public <K,V>A withNodeSelector(java.util.Map<java.lang.String,java.lang.String> nodeSelector);
  public java.lang.Boolean hasNodeSelector();
  public A addToObservedConfig(java.lang.String key,java.lang.Object value);
  public A addToObservedConfig(java.util.Map<java.lang.String,java.lang.Object> map);
  public A removeFromObservedConfig(java.lang.String key);
  public A removeFromObservedConfig(java.util.Map<java.lang.String,java.lang.Object> map);
  public java.util.Map<java.lang.String,java.lang.Object> getObservedConfig();
  public <K,V>A withObservedConfig(java.util.Map<java.lang.String,java.lang.Object> observedConfig);
  public java.lang.Boolean hasObservedConfig();
  public java.lang.String getOperatorLogLevel();
  public A withOperatorLogLevel(java.lang.String operatorLogLevel);
  public java.lang.Boolean hasOperatorLogLevel();
  
  /**
   * Method is deprecated. use withOperatorLogLevel instead.
   */
  @java.lang.Deprecated
  public A withNewOperatorLogLevel(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildProxy instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigProxy getProxy();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigProxy buildProxy();
  public A withProxy(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigProxy proxy);
  public java.lang.Boolean hasProxy();
  public A withNewProxy(java.lang.String http,java.lang.String https,java.lang.String noProxy);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ProxyNested<A> withNewProxy();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ProxyNested<A> withNewProxyLike(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigProxy item);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ProxyNested<A> editProxy();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ProxyNested<A> editOrNewProxy();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ProxyNested<A> editOrNewProxyLike(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigProxy item);
  public java.lang.Boolean getReadOnly();
  public A withReadOnly(java.lang.Boolean readOnly);
  public java.lang.Boolean hasReadOnly();
  public java.lang.Integer getReplicas();
  public A withReplicas(java.lang.Integer replicas);
  public java.lang.Boolean hasReplicas();
  
  /**
   * This method has been deprecated, please use method buildRequests instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRequests getRequests();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRequests buildRequests();
  public A withRequests(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRequests requests);
  public java.lang.Boolean hasRequests();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RequestsNested<A> withNewRequests();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RequestsNested<A> withNewRequestsLike(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRequests item);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RequestsNested<A> editRequests();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RequestsNested<A> editOrNewRequests();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RequestsNested<A> editOrNewRequestsLike(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRequests item);
  
  /**
   * This method has been deprecated, please use method buildResources instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ResourceRequirements getResources();
  public io.fabric8.kubernetes.api.model.ResourceRequirements buildResources();
  public A withResources(io.fabric8.kubernetes.api.model.ResourceRequirements resources);
  public java.lang.Boolean hasResources();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ResourcesNested<A> withNewResources();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ResourcesNested<A> withNewResourcesLike(io.fabric8.kubernetes.api.model.ResourceRequirements item);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ResourcesNested<A> editResources();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ResourcesNested<A> editOrNewResources();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ResourcesNested<A> editOrNewResourcesLike(io.fabric8.kubernetes.api.model.ResourceRequirements item);
  public java.lang.String getRolloutStrategy();
  public A withRolloutStrategy(java.lang.String rolloutStrategy);
  public java.lang.Boolean hasRolloutStrategy();
  
  /**
   * Method is deprecated. use withRolloutStrategy instead.
   */
  @java.lang.Deprecated
  public A withNewRolloutStrategy(java.lang.String arg0);
  public A addToRoutes(java.lang.Integer index,io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute item);
  public A setToRoutes(java.lang.Integer index,io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute item);
  public A addToRoutes(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute... items);
  public A addAllToRoutes(java.util.Collection<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute> items);
  public A removeFromRoutes(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute... items);
  public A removeAllFromRoutes(java.util.Collection<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute> items);
  public A removeMatchingFromRoutes(java.util.function.Predicate<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRouteBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildRoutes instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute> getRoutes();
  public java.util.List<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute> buildRoutes();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute buildRoute(java.lang.Integer index);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute buildFirstRoute();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute buildLastRoute();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute buildMatchingRoute(java.util.function.Predicate<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRouteBuilder> predicate);
  public java.lang.Boolean hasMatchingRoute(java.util.function.Predicate<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRouteBuilder> predicate);
  public A withRoutes(java.util.List<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute> routes);
  public A withRoutes(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute... routes);
  public java.lang.Boolean hasRoutes();
  public A addNewRoute(java.lang.String hostname,java.lang.String name,java.lang.String secretName);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<A> addNewRoute();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<A> addNewRouteLike(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute item);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<A> setNewRouteLike(java.lang.Integer index,io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRoute item);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<A> editRoute(java.lang.Integer index);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<A> editFirstRoute();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<A> editLastRoute();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<A> editMatchingRoute(java.util.function.Predicate<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRouteBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildStorage instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigStorage getStorage();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigStorage buildStorage();
  public A withStorage(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigStorage storage);
  public java.lang.Boolean hasStorage();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.StorageNested<A> withNewStorage();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.StorageNested<A> withNewStorageLike(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigStorage item);
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.StorageNested<A> editStorage();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.StorageNested<A> editOrNewStorage();
  public io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.StorageNested<A> editOrNewStorageLike(io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigStorage item);
  public A addToTolerations(java.lang.Integer index,io.fabric8.kubernetes.api.model.Toleration item);
  public A setToTolerations(java.lang.Integer index,io.fabric8.kubernetes.api.model.Toleration item);
  public A addToTolerations(io.fabric8.kubernetes.api.model.Toleration... items);
  public A addAllToTolerations(java.util.Collection<io.fabric8.kubernetes.api.model.Toleration> items);
  public A removeFromTolerations(io.fabric8.kubernetes.api.model.Toleration... items);
  public A removeAllFromTolerations(java.util.Collection<io.fabric8.kubernetes.api.model.Toleration> items);
  public java.util.List<io.fabric8.kubernetes.api.model.Toleration> getTolerations();
  public io.fabric8.kubernetes.api.model.Toleration getToleration(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.Toleration getFirstToleration();
  public io.fabric8.kubernetes.api.model.Toleration getLastToleration();
  public io.fabric8.kubernetes.api.model.Toleration getMatchingToleration(java.util.function.Predicate<io.fabric8.kubernetes.api.model.Toleration> predicate);
  public java.lang.Boolean hasMatchingToleration(java.util.function.Predicate<io.fabric8.kubernetes.api.model.Toleration> predicate);
  public A withTolerations(java.util.List<io.fabric8.kubernetes.api.model.Toleration> tolerations);
  public A withTolerations(io.fabric8.kubernetes.api.model.Toleration... tolerations);
  public java.lang.Boolean hasTolerations();
  public A addNewToleration(java.lang.String effect,java.lang.String key,java.lang.String operator,java.lang.Long tolerationSeconds,java.lang.String value);
  public A addToUnsupportedConfigOverrides(java.lang.String key,java.lang.Object value);
  public A addToUnsupportedConfigOverrides(java.util.Map<java.lang.String,java.lang.Object> map);
  public A removeFromUnsupportedConfigOverrides(java.lang.String key);
  public A removeFromUnsupportedConfigOverrides(java.util.Map<java.lang.String,java.lang.Object> map);
  public java.util.Map<java.lang.String,java.lang.Object> getUnsupportedConfigOverrides();
  public <K,V>A withUnsupportedConfigOverrides(java.util.Map<java.lang.String,java.lang.Object> unsupportedConfigOverrides);
  public java.lang.Boolean hasUnsupportedConfigOverrides();
  public interface ProxyNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigProxyFluent<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ProxyNested<N>>{
    public N and();
    public N endProxy();
    
  }
  public interface RequestsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRequestsFluent<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RequestsNested<N>>{
    public N and();
    public N endRequests();
    
  }
  public interface ResourcesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ResourceRequirementsFluent<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.ResourcesNested<N>>{
    public N and();
    public N endResources();
    
  }
  public interface RoutesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigRouteFluent<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.RoutesNested<N>>{
    public N and();
    public N endRoute();
    
  }
  public interface StorageNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistryConfigStorageFluent<io.fabric8.openshift.api.model.miscellaneous.imageregistry.operator.v1.ImageRegistrySpecFluent.StorageNested<N>>{
    public N and();
    public N endStorage();
    
  }
  
}